Index: source/simulation2/helpers/Geometry.h
===================================================================
--- source/simulation2/helpers/Geometry.h	(revision 13108)
+++ source/simulation2/helpers/Geometry.h	(working copy)
@@ -32,51 +32,67 @@
 {
 
 /**
- * Checks if a point is inside the given rotated square or rectangle.
+ * Checks if a point is inside the given rotated rectangle.
+ * Points precisely on an edge are considered to be inside.
  *
- * @note Currently assumes the @p u and @p v vectors are perpendicular.
- * @param point point vector of the point that is to be tested relative to the origin (center) of the shape.
- * @param u rotated X axis unit vector relative to the absolute XZ plane. Indicates the orientation of the rectangle. If not rotated,
- *          this value is the absolute X axis unit vector (1,0). If rotated by angle theta, this should be (cos theta, -sin theta), as
- *          the absolute Z axis points down in the unit circle.
- * @param v rotated Z axis unit vector relative to the absolute XZ plane. Indicates the orientation of the rectangle. If not rotated,
- *          this value is the absolute Z axis unit vector (0,1). If rotated by angle theta, this should be (sin theta, cos theta), as
- *          the absolute Z axis points down in the unit circle.
- * @param halfSize Holds half the dimensions of the shape along the u and v vectors, respectively.
+ * The rectangle is defined by the four vertexes
+ * (+/-u*halfSize.X +/-v*halfSize.Y).
  *
- * @return true if @p point is inside the square with rotated X axis unit vector @p u and rotated Z axis unit vector @p v,
- * and half dimensions specified by @p halfSizes.
+ * The @p u and @p v vectors must be perpendicular.
  */
-bool PointIsInSquare(CFixedVector2D point, CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
+bool PointIsInSquare(CFixedVector2D point,
+	CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
 
+/**
+ * Returns a vector (bx,by) such that every point inside
+ * the given rotated rectangle has coordinates
+ * (x,y) with -bx <= x <= bx, -by <= y < by.
+ *
+ * The rectangle is defined by the four vertexes
+ * (+/-u*halfSize.X +/-v*halfSize.Y).
+ */
 CFixedVector2D GetHalfBoundingBox(CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
 
-fixed DistanceToSquare(CFixedVector2D point, CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
-
 /**
- * Given a circle of radius @p radius, and a chord of length @p chordLength on this circle, computes the central angle formed by 
- * connecting the chord's endpoints to the center of the circle.
- * 
- * @param radius Radius of the circle; must be strictly positive.
+ * Returns the minimum Euclidean distance from the given point to
+ * any point on the boundary of the given rotated rectangle.
+ *
+ * If @p countInsideAsZero is true, and the point is inside the rectangle,
+ * it will return 0.
+ * If @p countInsideAsZero is false, the (positive) distance to the boundary
+ * will be returned regardless of where the point is.
+ *
+ * The rectangle is defined by the four vertexes
+ * (+/-u*halfSize.X +/-v*halfSize.Y).
+ *
+ * The @p u and @p v vectors must be perpendicular and unit length.
  */
-float ChordToCentralAngle(const float chordLength, const float radius);
+fixed DistanceToSquare(CFixedVector2D point,
+	CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize,
+	bool countInsideAsZero = false);
 
 /**
- * Find point closest to the given point on the edge of the given square or rectangle.
+ * Returns a point on the boundary of the given rotated rectangle
+ * that is closest (or equally closest) to the given point
+ * in Euclidean distance.
  *
- * @note Currently assumes the @p u and @p v vectors are perpendicular.
- * @param point point vector of the point we want to get the nearest edge point for, relative to the origin (center) of the shape.
- * @param u rotated X axis unit vector, relative to the absolute XZ plane. Indicates the orientation of the shape. If not rotated,
- *          this value is the absolute X axis unit vector (1,0). If rotated by angle theta, this should be (cos theta, -sin theta).
- * @param v rotated Z axis unit vector, relative to the absolute XZ plane. Indicates the orientation of the shape. If not rotated,
- *          this value is the absolute Z axis unit vector (0,1). If rotated by angle theta, this should be (sin theta, cos theta).
- * @param halfSize Holds half the dimensions of the shape along the u and v vectors, respectively.
+ * The rectangle is defined by the four vertexes
+ * (+/-u*halfSize.X +/-v*halfSize.Y).
  *
- * @return point that is closest to @p point on the edge of the square specified by orientation unit vectors @p u and @p v and half
- *	dimensions @p halfSize, relative to the center of the square
+ * The @p u and @p v vectors must be perpendicular and unit length.
  */
-CFixedVector2D NearestPointOnSquare(CFixedVector2D point, CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
+CFixedVector2D NearestPointOnSquare(CFixedVector2D point,
+	CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
 
+/**
+ * Given a circle of radius @p radius, and a chord of length @p chordLength
+ * on this circle, computes the central angle formed by
+ * connecting the chord's endpoints to the center of the circle.
+ *
+ * @param radius Radius of the circle; must be strictly positive.
+ */
+float ChordToCentralAngle(const float chordLength, const float radius);
+
 bool TestRaySquare(CFixedVector2D a, CFixedVector2D b, CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize);
 
 bool TestRayAASquare(CFixedVector2D a, CFixedVector2D b, CFixedVector2D halfSize);
Index: source/simulation2/helpers/Geometry.cpp
===================================================================
--- source/simulation2/helpers/Geometry.cpp	(revision 13108)
+++ source/simulation2/helpers/Geometry.cpp	(working copy)
@@ -50,7 +50,7 @@
 	return acosf(1.f - SQR(chordLength)/(2.f*SQR(radius))); // cfr. law of cosines
 }
 
-fixed Geometry::DistanceToSquare(CFixedVector2D point, CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize)
+fixed Geometry::DistanceToSquare(CFixedVector2D point, CFixedVector2D u, CFixedVector2D v, CFixedVector2D halfSize, bool countInsideAsZero)
 {
 	/*
 	 * Relative to its own coordinate system, we have a square like:
@@ -92,7 +92,12 @@
 		fixed closest = (dv.Absolute() - hh).Absolute(); // horizontal edges
 
 		if (-hh < dv && dv < hh) // region I
-			closest = std::min(closest, (du.Absolute() - hw).Absolute()); // vertical edges
+		{
+			if (countInsideAsZero)
+				closest = fixed::Zero();
+			else
+				closest = std::min(closest, (du.Absolute() - hw).Absolute()); // vertical edges
+		}
 
 		return closest;
 	}
Index: source/simulation2/components/tests/test_Pathfinder.h
===================================================================
--- source/simulation2/components/tests/test_Pathfinder.h	(revision 13108)
+++ source/simulation2/components/tests/test_Pathfinder.h	(working copy)
@@ -26,6 +26,7 @@
 #include "lib/timer.h"
 #include "lib/tex/tex.h"
 #include "ps/Loader.h"
+#include "ps/Pyrogenesis.h"
 #include "simulation2/Simulation2.h"
 
 class TestCmpPathfinder : public CxxTest::TestSuite
@@ -85,7 +86,7 @@
 		ICmpPathfinder::Goal goal = { ICmpPathfinder::Goal::POINT, x1, z1 };
 
 		ICmpPathfinder::Path path;
-		cmp->ComputePath(x0, z0, goal, cmp->GetPassabilityClass("default"), cmp->GetCostClass("default"), path);
+		cmp->ComputePath(x0, z0, goal, cmp->GetPassabilityClass("default"), path);
 		for (size_t i = 0; i < path.m_Waypoints.size(); ++i)
 			printf("%d: %f %f\n", (int)i, path.m_Waypoints[i].x.ToDouble(), path.m_Waypoints[i].z.ToDouble());
 #endif
@@ -99,10 +100,10 @@
 			entity_pos_t z0 = entity_pos_t::FromInt(rand() % 512);
 			entity_pos_t x1 = x0 + entity_pos_t::FromInt(rand() % 64);
 			entity_pos_t z1 = z0 + entity_pos_t::FromInt(rand() % 64);
-			ICmpPathfinder::Goal goal = { ICmpPathfinder::Goal::POINT, x1, z1 };
+			PathGoal goal = { PathGoal::POINT, x1, z1 };
 
 			ICmpPathfinder::Path path;
-			cmp->ComputePath(x0, z0, goal, cmp->GetPassabilityClass("default"), cmp->GetCostClass("default"), path);
+			cmp->ComputePath(x0, z0, goal, cmp->GetPassabilityClass("default"), path);
 		}
 
 		t = timer_Time() - t;
@@ -133,10 +134,224 @@
 		}
 
 		NullObstructionFilter filter;
-		ICmpPathfinder::Goal goal = { ICmpPathfinder::Goal::POINT, range, range };
+		PathGoal goal = { PathGoal::POINT, range, range };
 		ICmpPathfinder::Path path;
 		cmpPathfinder->ComputeShortPath(filter, range/3, range/3, fixed::FromInt(2), range, goal, 0, path);
 		for (size_t i = 0; i < path.m_Waypoints.size(); ++i)
 			printf("# %d: %f %f\n", (int)i, path.m_Waypoints[i].x.ToFloat(), path.m_Waypoints[i].z.ToFloat());
 	}
+
+	template<typename T>
+	void DumpGrid(std::ostream& stream, const Grid<T>& grid, int mask)
+	{
+		for (u16 j = 0; j < grid.m_H; ++j)
+		{
+			for (u16 i = 0; i < grid.m_W; )
+			{
+				if (!(grid.get(i, j) & mask))
+				{
+					i++;
+					continue;
+				}
+
+				u16 i0 = i;
+				for (i = i0+1; ; ++i)
+				{
+					if (i >= grid.m_W || !(grid.get(i, j) & mask))
+					{
+						stream << "  <rect x='" << i0 << "' y='" << j << "' width='" << (i-i0) << "' height='1'/>\n";
+						break;
+					}
+				}
+			}
+		}
+	}
+
+#define USE_JPS 1
+
+	void test_perf2()
+	{
+		CTerrain terrain;
+
+		CSimulation2 sim2(NULL, &terrain);
+		sim2.LoadDefaultScripts();
+		sim2.ResetState();
+
+		CMapReader* mapReader = new CMapReader(); // it'll call "delete this" itself
+
+		LDR_BeginRegistering();
+		mapReader->LoadMap(L"maps/scenarios/Peloponnese.pmp", &terrain, NULL, NULL, NULL, NULL, NULL, NULL,
+			&sim2, &sim2.GetSimContext(), -1, false);
+		LDR_EndRegistering();
+		TS_ASSERT_OK(LDR_NonprogressiveLoad());
+
+		sim2.Update(0);
+
+		std::ofstream stream(OsString("perf2.html").c_str(), std::ofstream::out | std::ofstream::trunc);
+
+		CmpPtr<ICmpObstructionManager> cmpObstructionManager(sim2, SYSTEM_ENTITY);
+		CmpPtr<ICmpPathfinder> cmpPathfinder(sim2, SYSTEM_ENTITY);
+
+		ICmpPathfinder::pass_class_t obstructionsMask = cmpPathfinder->GetPassabilityClass("default") | ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING;
+		const Grid<u16>& obstructions = cmpPathfinder->GetPassabilityGrid();
+
+		int scale = 1;
+		stream << "<!DOCTYPE html>\n";
+		stream << "<style>\n";
+		stream << ".passability rect { fill: black; }\n";
+		stream << ".astar-open rect { fill: rgba(255,255,0,0.75); }\n";
+		stream << ".astar-closed rect { fill: rgba(255,0,0,0.75); }\n";
+//		stream << ".astar-closed rect { fill: rgba(0,255,0,0.75); }\n";
+		stream << ".path { stroke: rgba(0,0,255,0.75); stroke-width: 1; fill: none; }\n";
+		stream << "</style>\n";
+		stream << "<svg width='" << obstructions.m_W*scale << "' height='" << obstructions.m_H*scale << "'>\n";
+		stream << "<g transform='translate(0 " << obstructions.m_H*scale << ") scale(" << scale << " -" << scale << ")'>\n";
+
+		stream << " <g class='passability'>\n";
+		DumpGrid(stream, obstructions, obstructionsMask);
+		stream << " </g>\n";
+
+		DumpPath(stream, 128*4, 256*4, 128*4, 384*4, cmpPathfinder);
+// 	  	RepeatPath(500, 128*4, 256*4, 128*4, 384*4, cmpPathfinder);
+// //		RepeatPath(100, 128*4, 256*4, 128*4, 384*4, cmpPathfinder);
+// 
+// 		DumpPath(stream, 128*4, 204*4, 192*4, 204*4, cmpPathfinder);
+// 
+// 		DumpPath(stream, 128*4, 230*4, 32*4, 230*4, cmpPathfinder);
+
+		stream << "</g>\n";
+		stream << "</svg>\n";
+	}
+	
+	void test_perf3()
+	{
+		CTerrain terrain;
+
+		CSimulation2 sim2(NULL, &terrain);
+		sim2.LoadDefaultScripts();
+		sim2.ResetState();
+
+		CMapReader* mapReader = new CMapReader(); // it'll call "delete this" itself
+
+		LDR_BeginRegistering();
+		mapReader->LoadMap(L"maps/scenarios/pathfindtest7.pmp", &terrain, NULL, NULL, NULL, NULL, NULL, NULL,
+			&sim2, &sim2.GetSimContext(), -1, false);
+		LDR_EndRegistering();
+		TS_ASSERT_OK(LDR_NonprogressiveLoad());
+
+		sim2.Update(0);
+
+		std::ofstream stream(OsString("perf3.html").c_str(), std::ofstream::out | std::ofstream::trunc);
+
+		CmpPtr<ICmpObstructionManager> cmpObstructionManager(sim2, SYSTEM_ENTITY);
+		CmpPtr<ICmpPathfinder> cmpPathfinder(sim2, SYSTEM_ENTITY);
+
+		ICmpPathfinder::pass_class_t obstructionsMask = cmpPathfinder->GetPassabilityClass("default") | ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING;
+		const Grid<u16>& obstructions = cmpPathfinder->GetPassabilityGrid();
+
+		int scale = 31;
+		stream << "<!DOCTYPE html>\n";
+		stream << "<style>\n";
+		stream << ".passability rect { fill: black; }\n";
+		stream << ".astar-open rect { fill: rgba(255,255,0,0.75); }\n";
+		stream << ".astar-closed rect { fill: rgba(255,0,0,0.75); }\n";
+		stream << ".path { stroke: rgba(0,0,255,0.75); stroke-width: " << (1.0f / scale) << "; fill: none; }\n";
+		stream << "</style>\n";
+		stream << "<svg width='" << obstructions.m_W*scale << "' height='" << obstructions.m_H*scale << "'>\n";
+		stream << "<defs><pattern id='grid' width='1' height='1' patternUnits='userSpaceOnUse'>\n";
+		stream << "<rect fill='none' stroke='#888' stroke-width='" << (1.0f / scale) << "' width='" << scale << "' height='" << scale << "'/>\n";
+		stream << "</pattern></defs>\n";
+		stream << "<g transform='translate(0 " << obstructions.m_H*scale << ") scale(" << scale << " -" << scale << ")'>\n";
+
+		stream << " <g class='passability'>\n";
+		DumpGrid(stream, obstructions, obstructionsMask);
+		stream << " </g>\n";
+
+		for (int j = 160; j < 190; ++j)
+			for (int i = 220; i < 290; ++i)
+				DumpPath(stream, 230, 178, i, j, cmpPathfinder);
+
+		stream << "<rect fill='url(#grid)' width='100%' height='100%'/>\n";
+		stream << "</g>\n";
+		stream << "</svg>\n";
+	}
+
+	void DumpPath(std::ostream& stream, int i0, int j0, int i1, int j1, CmpPtr<ICmpPathfinder>& cmpPathfinder)
+	{
+		entity_pos_t x0 = entity_pos_t::FromInt(i0);
+		entity_pos_t z0 = entity_pos_t::FromInt(j0);
+		entity_pos_t x1 = entity_pos_t::FromInt(i1);
+		entity_pos_t z1 = entity_pos_t::FromInt(j1);
+
+		PathGoal goal = { PathGoal::POINT, x1, z1 };
+
+		ICmpPathfinder::Path path;
+#if USE_JPS
+		cmpPathfinder->ComputePathJPS(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), path);
+#else
+		cmpPathfinder->ComputePath(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), path);
+#endif
+
+		u32 debugSteps;
+		double debugTime;
+		Grid<u8> debugGrid;
+#if USE_JPS
+		cmpPathfinder->GetDebugDataJPS(debugSteps, debugTime, debugGrid);
+#else
+		cmpPathfinder->GetDebugData(debugSteps, debugTime, debugGrid);
+#endif
+// 		stream << " <g style='visibility:hidden'>\n";
+
+		stream << " <g>\n";
+// 		stream << " <g class='astar-open'>\n";
+// 		DumpGrid(stream, debugGrid, 1);
+// 		stream << " </g>\n";
+// 		stream << " <g class='astar-closed'>\n";
+// 		DumpGrid(stream, debugGrid, 2);
+// 		stream << " </g>\n";
+// 		stream << " <g class='astar-closed'>\n";
+// 		DumpGrid(stream, debugGrid, 3);
+// 		stream << " </g>\n";
+		stream << " </g>\n";
+
+		stream << " <polyline";
+		stream << " onmouseover='this.previousElementSibling.style.visibility=\"visible\"' onmouseout='this.previousElementSibling.style.visibility=\"hidden\"'";
+		double length = 0;
+		for (ssize_t i = 0; i < (ssize_t)path.m_Waypoints.size()-1; ++i)
+		{
+			double dx = (path.m_Waypoints[i+1].x - path.m_Waypoints[i].x).ToDouble();
+			double dz = (path.m_Waypoints[i+1].z - path.m_Waypoints[i].z).ToDouble();
+			ENSURE(dx == 0 || dz == 0 || abs(dx) == abs(dz));
+			length += sqrt(dx*dx + dz*dz);
+		}
+		stream << " title='length: " << length << "; tiles explored: " << debugSteps << "; time: " << debugTime*1000 << " msec'";
+		stream << " class='path' points='";
+		for (size_t i = 0; i < path.m_Waypoints.size(); ++i)
+			stream << path.m_Waypoints[i].x.ToDouble()*ICmpObstructionManager::NAVCELLS_PER_TILE/TERRAIN_TILE_SIZE << "," << path.m_Waypoints[i].z.ToDouble()*ICmpObstructionManager::NAVCELLS_PER_TILE/TERRAIN_TILE_SIZE << " ";
+		stream << "'/>\n";
+	}
+
+	void RepeatPath(int n, int i0, int j0, int i1, int j1, CmpPtr<ICmpPathfinder>& cmpPathfinder)
+	{
+		entity_pos_t x0 = entity_pos_t::FromInt(i0);
+		entity_pos_t z0 = entity_pos_t::FromInt(j0);
+		entity_pos_t x1 = entity_pos_t::FromInt(i1);
+		entity_pos_t z1 = entity_pos_t::FromInt(j1);
+
+		PathGoal goal = { PathGoal::POINT, x1, z1 };
+
+		double t = timer_Time();
+		for (int i = 0; i < n; ++i)
+		{
+			ICmpPathfinder::Path path;
+#if USE_JPS
+			cmpPathfinder->ComputePathJPS(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), path);
+#else
+			cmpPathfinder->ComputePath(x0, z0, goal, cmpPathfinder->GetPassabilityClass("default"), path);
+#endif
+		}
+		t = timer_Time() - t;
+		debug_printf(L"### RepeatPath %fms each (%fs total)\n", 1000*t / n, t);
+	}
+
 };
Index: source/simulation2/components/ICmpUnitMotion.h
===================================================================
--- source/simulation2/components/ICmpUnitMotion.h	(revision 13108)
+++ source/simulation2/components/ICmpUnitMotion.h	(working copy)
@@ -1,4 +1,4 @@
-/* Copyright (C) 2011 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -38,6 +38,7 @@
 
 	/**
 	 * Attempt to walk into range of a to a given point, or as close as possible.
+	 * The range is measured from the center of the unit.
 	 * If the unit is already in range, or cannot move anywhere at all, or if there is
 	 * some other error, then returns false.
 	 * Otherwise, returns true and sends a MotionChanged message after starting to move,
@@ -60,6 +61,8 @@
 
 	/**
 	 * Attempt to walk into range of a given target entity, or as close as possible.
+	 * The range is measured between approximately the edges of the unit and the target, so that
+	 * maxRange=0 is not unreachably close to the target.
 	 * If the unit is already in range, or cannot move anywhere at all, or if there is
 	 * some other error, then returns false.
 	 * Otherwise, returns true and sends a MotionChanged message after starting to move,
Index: source/simulation2/components/ICmpTerritoryManager.h
===================================================================
--- source/simulation2/components/ICmpTerritoryManager.h	(revision 13108)
+++ source/simulation2/components/ICmpTerritoryManager.h	(working copy)
@@ -29,6 +29,14 @@
 public:
 	virtual bool NeedUpdate(size_t* dirtyID) = 0;
 
+	/**
+	 * Number of pathfinder navcells per territory tile.
+	 * Passability data is stored per navcell, but we probably don't need that much
+	 * resolution, and a lower resolution can make the boundary lines look prettier
+	 * and will take less memory, so we downsample the passability data.
+	 */
+	static const int NAVCELLS_PER_TERRITORY_TILE = 8;
+
 	static const int TERRITORY_PLAYER_MASK = 0x3F;
 	static const int TERRITORY_CONNECTED_MASK = 0x40;
 	static const int TERRITORY_PROCESSED_MASK = 0x80; //< For internal use; marks a tile as processed.
Index: source/simulation2/components/ICmpPathfinder.h
===================================================================
--- source/simulation2/components/ICmpPathfinder.h	(revision 13108)
+++ source/simulation2/components/ICmpPathfinder.h	(working copy)
@@ -1,4 +1,4 @@
-/* Copyright (C) 2011 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -20,6 +20,7 @@
 
 #include "simulation2/system/Interface.h"
 
+#include "simulation2/helpers/PathGoal.h"
 #include "simulation2/helpers/Position.h"
 
 #include "maths/FixedVector2D.h"
@@ -38,7 +39,7 @@
  * accounts for terrain costs but ignore units, and a 'short' vertex-based pathfinder that
  * provides precise paths and avoids other units.
  *
- * Both use the same concept of a Goal: either a point, circle or square.
+ * Both use the same concept of a PathGoal: either a point, circle or square.
  * (If the starting point is inside the goal shape then the path will move outwards
  * to reach the shape's outline.)
  *
@@ -48,20 +49,7 @@
 {
 public:
 	typedef u16 pass_class_t;
-	typedef u8 cost_class_t;
 
-	struct Goal
-	{
-		enum Type {
-			POINT,
-			CIRCLE,
-			SQUARE
-		} type;
-		entity_pos_t x, z; // position of center
-		CFixedVector2D u, v; // if SQUARE, then orthogonal unit axes
-		entity_pos_t hw, hh; // if SQUARE, then half width & height; if CIRCLE, then hw is radius
-	};
-
 	struct Waypoint
 	{
 		entity_pos_t x, z;
@@ -87,12 +75,6 @@
 	 */
 	virtual pass_class_t GetPassabilityClass(const std::string& name) = 0;
 
-	/**
-	 * Get the tag for a given movement cost class name.
-	 * Logs an error and returns something acceptable if the name is unrecognised.
-	 */
-	virtual cost_class_t GetCostClass(const std::string& name) = 0;
-
 	virtual const Grid<u16>& GetPassabilityGrid() = 0;
 
 	/**
@@ -100,20 +82,25 @@
 	 * The waypoints correspond to the centers of horizontally/vertically adjacent tiles
 	 * along the path.
 	 */
-	virtual void ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& ret) = 0;
+	virtual void ComputePath(entity_pos_t x0, entity_pos_t z0, const PathGoal& goal, pass_class_t passClass, Path& ret) = 0;
 
 	/**
+	 * Equivalent to ComputePath, but using the JPS pathfinder.
+	 */
+	virtual void ComputePathJPS(entity_pos_t x0, entity_pos_t z0, const PathGoal& goal, pass_class_t passClass, Path& ret) = 0;
+
+	/**
 	 * Asynchronous version of ComputePath.
 	 * The result will be sent as CMessagePathResult to 'notify'.
 	 * Returns a unique non-zero number, which will match the 'ticket' in the result,
 	 * so callers can recognise each individual request they make.
 	 */
-	virtual u32 ComputePathAsync(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, entity_id_t notify) = 0;
+	virtual u32 ComputePathAsync(entity_pos_t x0, entity_pos_t z0, const PathGoal& goal, pass_class_t passClass, entity_id_t notify) = 0;
 
 	/**
 	 * If the debug overlay is enabled, render the path that will computed by ComputePath.
 	 */
-	virtual void SetDebugPath(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass) = 0;
+	virtual void SetDebugPath(entity_pos_t x0, entity_pos_t z0, const PathGoal& goal, pass_class_t passClass) = 0;
 
 	/**
 	 * Compute a precise path from the given point to the goal, and return the set of waypoints.
@@ -121,7 +108,7 @@
 	 * a unit of radius 'r' will be able to follow the path with no collisions.
 	 * The path is restricted to a box of radius 'range' from the starting point.
 	 */
-	virtual void ComputeShortPath(const IObstructionTestFilter& filter, entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const Goal& goal, pass_class_t passClass, Path& ret) = 0;
+	virtual void ComputeShortPath(const IObstructionTestFilter& filter, entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const PathGoal& goal, pass_class_t passClass, Path& ret) = 0;
 
 	/**
 	 * Asynchronous version of ComputeShortPath (using ControlGroupObstructionFilter).
@@ -129,18 +116,12 @@
 	 * Returns a unique non-zero number, which will match the 'ticket' in the result,
 	 * so callers can recognise each individual request they make.
 	 */
-	virtual u32 ComputeShortPathAsync(entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const Goal& goal, pass_class_t passClass, bool avoidMovingUnits, entity_id_t group, entity_id_t notify) = 0;
+	virtual u32 ComputeShortPathAsync(entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const PathGoal& goal, pass_class_t passClass, bool avoidMovingUnits, entity_id_t group, entity_id_t notify) = 0;
 
 	/**
-	 * Find the speed factor (typically around 1.0) for a unit of the given cost class
-	 * at the given position.
-	 */
-	virtual fixed GetMovementSpeed(entity_pos_t x0, entity_pos_t z0, cost_class_t costClass) = 0;
-
-	/**
 	 * Returns the coordinates of the point on the goal that is closest to pos in a straight line.
 	 */
-	virtual CFixedVector2D GetNearestPointOnGoal(CFixedVector2D pos, const Goal& goal) = 0;
+	virtual CFixedVector2D GetNearestPointOnGoal(CFixedVector2D pos, const PathGoal& goal) = 0;
 
 	/**
 	 * Check whether the given movement line is valid and doesn't hit any obstructions
@@ -178,6 +159,16 @@
 	 */
 	virtual void ProcessSameTurnMoves() = 0;
 
+	/**
+	 * Returns some stats about the last ComputePath.
+	 */
+	virtual void GetDebugData(u32& steps, double& time, Grid<u8>& grid) = 0;
+
+	/**
+	 * Returns some stats about the last ComputePathJPS.
+	 */
+	virtual void GetDebugDataJPS(u32& steps, double& time, Grid<u8>& grid) = 0;
+
 	DECLARE_INTERFACE_TYPE(Pathfinder)
 };
 
Index: source/simulation2/components/ICmpObstructionManager.h
===================================================================
--- source/simulation2/components/ICmpObstructionManager.h	(revision 13108)
+++ source/simulation2/components/ICmpObstructionManager.h	(working copy)
@@ -48,13 +48,30 @@
  * Units can be marked as either moving or stationary, which simply determines whether
  * certain filters include or exclude them.
  *
- * The @c Rasterise function approximates the current set of shapes onto a 2D grid,
+ * The @c Rasterize function approximates the current set of shapes onto a 2D grid,
  * for use with tile-based pathfinding.
  */
 class ICmpObstructionManager : public IComponent
 {
 public:
 	/**
+	 * The pathfinders operate primarily over a navigation grid (a uniform-cost
+	 * 2D passability grid, with horizontal/vertical (not diagonal) connectivity).
+	 * This is based on the terrain tile passability, plus the rasterized shapes of
+	 * obstructions, all expanded outwards by the radius of the units.
+	 * Since units are much smaller than terrain tiles, the nav grid should be
+	 * higher resolution than the tiles.
+	 * We therefore split each terrain tile into NxN "nav cells" (for some integer N,
+	 * preferably a power of two).
+	 */
+	static const int NAVCELLS_PER_TILE = 4;
+
+	/**
+	 * Size of a navcell in metres ( = TERRAIN_TILE_SIZE / NAVCELLS_PER_TILE)
+	 */
+	static const fixed NAVCELL_SIZE;
+
+	/**
 	 * External identifiers for shapes.
 	 * (This is a struct rather than a raw u32 for type-safety.)
 	 */
@@ -205,7 +222,7 @@
 		std::vector<entity_id_t>* out) = 0;
 
 	/**
-	 * Bit-flags for Rasterise.
+	 * Bit-flags for Rasterize.
 	 */
 	enum TileObstruction
 	{
@@ -215,18 +232,27 @@
 	};
 
 	/**
-	 * Convert the current set of shapes onto a grid.
-	 * Tiles that are intersected by a pathfind-blocking shape will have TILE_OBSTRUCTED_PATHFINDING set;
-	 * tiles that are intersected by a foundation-blocking shape will also have TILE_OBSTRUCTED_FOUNDATION;
-	 * tiles that are outside the world bounds will also have TILE_OUTOFBOUNDS;
-	 * others will be set to 0.
-	 * This is very cheap if the grid has been rasterised before and the set of shapes has not changed.
-	 * @param grid the grid to be updated
-	 * @return true if any changes were made to the grid, false if it was already up-to-date
+	 * Convert the current set of shapes onto a navcell grid.
+	 * Shapes are expanded by the clearance radius @p expand.
+	 * Only shapes with at least one of the flags from @p requireMask will be considered.
+	 * @p setMask will be ORed onto the @p grid value for all navcells
+	 * that are wholly enclosed by an expanded shape.
 	 */
-	virtual bool Rasterise(Grid<u8>& grid) = 0;
+	virtual void Rasterize(Grid<u16>& grid, entity_pos_t expand, ICmpObstructionManager::flags_t requireMask, u16 setMask) = 0;
 
 	/**
+	 * Returns whether obstructions have changed such that Rasterize will
+	 * return different data, since the last call to NeedUpdate with the same
+	 * @p dirtyID handle.
+	 * This should be first called with @p dirtyID pointing to 0; the function
+	 * will return true and update the pointed-at value to indicate the current
+	 * state. Pass the same pointer to subsequent calls, and the function either
+	 * will return false (if nothing relevant has changed), or will update the
+	 * value and return true (in which case you should call Rasterize again).
+	 */
+	virtual bool NeedUpdate(size_t* dirtyID) = 0;
+
+	/**
 	 * Standard representation for all types of shapes, for use with geometry processing code.
 	 */
 	struct ObstructionSquare
@@ -248,12 +274,12 @@
 	virtual void GetObstructionsInRange(const IObstructionTestFilter& filter, entity_pos_t x0, entity_pos_t z0, entity_pos_t x1, entity_pos_t z1, std::vector<ObstructionSquare>& squares) = 0;
 
 	/**
-	 * Find a single obstruction that blocks a unit at the given point with the given radius.
-	 * Static obstructions (buildings) are more important than unit obstructions, and
-	 * obstructions that cover the given point are more important than those that only cover
-	 * the point expanded by the radius.
+	 * Returns the entity IDs of all unit shapes that intersect the given
+	 * obstruction square.
+	 * (TODO: This currently ignores the clearance/radius values of units,
+	 * so it just uses the unexpanded obstruction shapes, which is not ideal.)
 	 */
-	virtual bool FindMostImportantObstruction(const IObstructionTestFilter& filter, entity_pos_t x, entity_pos_t z, entity_pos_t r, ObstructionSquare& square) = 0;
+	virtual void GetUnitsOnObstruction(const ObstructionSquare& square, std::vector<entity_id_t>& out) = 0;
 
 	/**
 	 * Get the obstruction square representing the given shape.
@@ -344,10 +370,19 @@
 	{
 		if (group == m_Group || (group2 != INVALID_ENTITY && group2 == m_Group))
 			return false;
+
+		// If an obstruction already blocks tile-based pathfinding,
+		// it will be handled as part of the terrain passability handling
+		// and doesn't need to be matched by this filter
+		if (flags & ICmpObstructionManager::FLAG_BLOCK_PATHFINDING)
+			return false;
+
 		if (!(flags & ICmpObstructionManager::FLAG_BLOCK_MOVEMENT))
 			return false;
+
 		if ((flags & ICmpObstructionManager::FLAG_MOVING) && !m_AvoidMoving)
 			return false;
+
 		return true;
 	}
 };
Index: source/simulation2/components/ICmpObstructionManager.cpp
===================================================================
--- source/simulation2/components/ICmpObstructionManager.cpp	(revision 13108)
+++ source/simulation2/components/ICmpObstructionManager.cpp	(working copy)
@@ -21,6 +21,10 @@
 
 #include "simulation2/system/InterfaceScripted.h"
 
+#include "graphics/Terrain.h"
+
+const fixed ICmpObstructionManager::NAVCELL_SIZE = fixed::FromInt(TERRAIN_TILE_SIZE) / NAVCELLS_PER_TILE;
+
 BEGIN_INTERFACE_WRAPPER(ObstructionManager)
 DEFINE_INTERFACE_METHOD_1("SetPassabilityCircular", void, ICmpObstructionManager, SetPassabilityCircular, bool)
 DEFINE_INTERFACE_METHOD_1("SetDebugOverlay", void, ICmpObstructionManager, SetDebugOverlay, bool)
